import Flutter
import UIKit
import SwiftUI

public class SwiftGetsettingsPlugin: NSObject, FlutterPlugin {
    private var channel:FlutterMethodChannel?
    private let eventListener: EventStateStreamHandler = EventStateStreamHandler()
    private var eventState: FlutterEventChannel?
    private var previousDeviceOrientation: UIDeviceOrientation = UIDevice.current.orientation

    init(with registrar: FlutterPluginRegistrar) { }
    //   private  var mSettingsObserver:SettingsValueChangeContentObserver = SettingsValueChangeContentObserver()


    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = SwiftGetsettingsPlugin(with: registrar)
            instance.channel = FlutterMethodChannel(name: "GetsettingsPlugin", binaryMessenger: registrar.messenger())
        registrar.addApplicationDelegate(instance)
        registrar.addMethodCallDelegate(instance, channel: instance.channel!)
        //
        instance.eventState = FlutterEventChannel(name: "GetSettingsChannel", binaryMessenger: registrar.messenger())
        instance.eventState?.setStreamHandler(instance.eventListener)
    }

    @objc func deviceOrientationChanged() {
        print("Orientation changed")
        inspectDeviceOrientation()
    }

    func inspectDeviceOrientation() {
        let orientation = UIDevice.current.orientation
        
       // if orientation == previousDeviceOrientation { return }
        previousDeviceOrientation = orientation
        print("deviceDidRotate")
    
//        switch UIDevice.current.orientation {
//        case .portrait:
//            print("portrait")
//        case .landscapeLeft:
//            print("landscapeLeft")
//        case .landscapeRight:
//            print("landscapeRight")
//        case .portraitUpsideDown:
//            print("portraitUpsideDown")
//        case .faceUp:
//            print("faceUp")
//        case .faceDown:
//            print("faceDown")
//        default: // .unknown
//            print("unknown")
//        }
        if orientation.isPortrait {
            print("isPortrait")
        }else if orientation.isLandscape {
            print("isLandscape")
        } else {
            print("isPortrait")
        }
    }
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        switch call.method {
        case "isRotationOn":
            //let device = UIDevice.current
            // UIDevice.current.beginGeneratingDeviceOrientationNotifications()
          //   var notificationCenter = NotificationCenter.default
//             NotificationCenter.default.addObserver(self, selector: #selector(deviceOrientationChanged),
//                 name: Notification.Name("UIDeviceOrientationDidChangeNotification"),
//                 object: nil)
            NotificationCenter.default.addObserver(self, selector: #selector(deviceOrientationChanged), name: NSNotification.Name("UIDeviceOrientationDidChangeNotification"), object: nil)

            print("isRotationOn!")
            break
        case "getPlatformVersion":
            result(UIDevice.current.systemVersion)
            break
        case "isiOSAppOnMac":
            var isMac = false
            if #available(iOS 14.0, *) {
                isMac = ProcessInfo.processInfo.isiOSAppOnMac
            }
            result(isMac)
            break;
        case "getUserAgent":
            result(getUserAgent())
            break
        default:
            result("unkown")
        }
    }
    func getUserAgent() -> String {
        let webview = UIWebView();
        guard let originalUA = webview.stringByEvaluatingJavaScript(from: "navigator.userAgent")else{
            return ""
        }
        return originalUA
    }
    public func detachFromEngine(for registrar: FlutterPluginRegistrar) {
        channel?.setMethodCallHandler(nil)
        eventState?.setStreamHandler(nil)
        
        NotificationCenter.default.removeObserver(self, name: NSNotification.Name("UIDeviceOrientationDidChangeNotification"), object: nil)
    }

}
